<html>
<body>

	<h3> 1. BIP Framework </h3>
<p>	
BIP stands for Behavior-Interaction-Priority and provides concepts for modeling and design of heterogeneous component-based systems using a layered approach. In BIP, systems are obtained by composition of atomic components (i.e., the behavior) with multiparty hierarchical interactions, and coordinated using dynamic priorities. BIP was mainly targeted for rigorous design of component-based systems, that is, not
only formal modeling and analysis but also correct-by-construction implementation and deployment. As such, BIP offers facilities to incorporate and execute external code within atomic components and/or multiparty interactions. 
</p>

<p>
The documentation of BIP 2 is available <a href="http://www-verimag.imag.fr/TOOLS/DCS/bip/doc/latest/pdf/BIP2.pdf">here</a>.
</p>

	<h3> 2. Stochastic extension </h3>
<p>
The Stochastic Real-Time BIP extension supports a new type of interaction, namely, stochastic.
These interactions are defined using specific annotations @stochastic(dist=”...”, clk=..., param=”...”) to tag components
ports. Such annotations specify a probability density function and its parameters through, respectively, the <i>dist</i> and <i>param</i> attributes, and to associate a clock
through the <i>clk</i> attribute. Currently, the language supports a number of built-in density functions : 'normal', 'gamma' and 'chi_squared'.
Note that 'uniform' and 'exponential' distributions can also be specified in the annotations.
</p>

<p>
Additional functions can be used through the same mechanism by defining a 'custom' distribution in the <i>dist</i> attribute,
and in <i>param</i> a file characterizing the underlying cumulative distribution.
An example of such a file can be found in the case study 'PTP'.
</p>

<p>
Details about the stochastic semantics of RT-BIP can be found <a href="http://www-verimag.imag.fr/TR/TR-2017-6.pdf">here</a>.
</p>


	<h3> 3. Model creation </h3>
<p>
After creating a new project, the next step is to design the model under study.
This can be done as follows : 
<ol>
	<li> Select the project in the project exploration panel, </li>
	<li> In the toolbar, click on the button with the tool tip text 'Create new file',</li>
	<li> In the dialog window, set the type to BIP model '.bip' and enter the name of the file,</li>
	<li> Click on the button 'ok',</li>
	<li> The file is added to the 'Models' folder of the corresponding project.</li>
	
</ol>

The same procedure can be followed to create source code files (.cpp/hpp) or distribution files (.txt).
</p>

	<h3> 4. Model importation </h3>
<p>
Separately designed models can be easily imported to a design project.
This is applicable to all kinds of modeling files (.bip/cpp/hpp/txt) but also compiled models (usually named 'system').
To do so:

<ol>
	<li> Select the project in the project exploration panel, </li>
	<li> In the central panel, select the 'model selection' tab,</li>
	<li> In the file chooser, select the file to import,</li>
	<li> Click on the button 'open',</li>
	<li> The file is added to the 'Models' folder of the corresponding project.</li>
	
</ol>
</p>

	<h3> 5. Model edition </h3>
<p>
A model file can be visualized by double-clicking on it in the project exploration panel, or by selecting it and clicking the 'Edit file' button. This file is displayed in a dedicated edition tab, added to the central panel.
The edition view provides facilities for BIP models design, that are :
<ul>
	<li> Keyword highlighting for the BIP 2 syntax</li>
	<li> Code auto-completion - This functionality allows to insert code patterns for a : package, atom type, compound type, etc.
This is activated by using the CTRL+SPACE keys. For example, type <code>pac</code> in the edition tab then type CTRL+SPACE, and finally select 'create package' in the popup menu. </li>
	<li> Find/Replace option using CTRL+F. Note that recursive replacements lead to infinite loops. eg. replacing 'do' by 'do this'.</li>
	<li> Multi-line commenting/uncommenting. Select several lines of code then press CTRL+SHIFT+C. This comments the uncommented selected lines, and vice versa.</li>
	<li> Double-click highlighting. In the code, double-click on a word. This highlights the word in blue and all its occurrences in yellow. This can be useful to track a variable during the development phase.</li>
	<li> Undo/Redo using respectively CTRL+Z and CTRL+Y.</li>
	<li> Multi-line tab/untab. Select several lines of code then press CTRL+T to tab all the lines and CTRL+SHIFT+T to untab the selected lines that are preceded by a tab.</li>
	
</ul>

After editing a file one has to make sure to save it before closing the tab.
We also recommand to frequently save your changes. 

</p>


	<h3> 6. Compilation </h3>
<p>
The compilation of a BIP model produces a 'system' file in the 'Models' folder.
The system is a runnable file that can be used in simulation and analyses.
To compile the BIP model, first open the edited model then click on the 'Compile BIP model' button.
After, select the type of BIP compiler and enter the name of the package and compound.
A dialog window opens and shows the progression of the compilation, including warnings and potential errors. 
</p>

<p>
The compilation operation generates a 'system' file.
Note that if a 'system' file already exists, the compilation overwrites the existing file.
Also note that the BIP model must be saved before compiling in order to take into account the last changes.
</p>

	<h3> 7. Simulation </h3>
<p>

	To simulate a system, first select it in the project explorator.
the URL of the selected system is loaded in the 'Model selection' tab.
Then, click on the 'Simulate system' button in the toolbox.
A simulation tab is open in the central panel.
Simulation parameters can be specified. 
Press 'Start simulation' to start the simulation.
Finally, you can stop then reset simulation by clicking the corresponding button.
</p>

<p>
For more information about the available parameters, you can run a sumilation with the parameter <code>--help</code>.
</p>

	

	

</body>
</html>
